#ifndef __buffer_h__
#define __buffer_h__

#pragma once

static struct{
  float (*LastBuffer)[MESH_SIZE][3],(*NewBuffer)[MESH_SIZE][3],(*NormalBuffer)[MESH_SIZE][3];
  int BufferIndex,Width,Height;
  float Mesh[3][MESH_SIZE][MESH_SIZE][3];
} Data={
  Data.Mesh[0],Data.Mesh[1],Data.Mesh[2],
  0
};

void swapBuffers(void){
  Data.BufferIndex^=1;
  Data.LastBuffer=Data.Mesh[!Data.BufferIndex];
  Data.NewBuffer=Data.Mesh[Data.BufferIndex];
  Data.NormalBuffer=Data.Mesh[2];
}

void initBuffer(void){
  int i,j;
  Data.BufferIndex=1;
  swapBuffers();
  for (i=0;i<MESH_SIZE;++i)
    for (j=0;j<MESH_SIZE;++j){
      Data.LastBuffer[i][j][0]=-1+2.*i/(MESH_SIZE-1);
      Data.LastBuffer[i][j][1]=-1+2.*j/(MESH_SIZE-1);
      Data.LastBuffer[i][j][2]=0;
      Data.NewBuffer[i][j][0]=-1+2.*i/(MESH_SIZE-1);
      Data.NewBuffer[i][j][1]=-1+2.*j/(MESH_SIZE-1);
      Data.NewBuffer[i][j][2]=0;
    }
}

#endif
